/*
 * @Overview 불량실적 등록 관리
 */

class Tb_defect_class {
  constructor(container) {
    this.ajaxUrl = "./reg_defect_result.ajax.php";
    this.container = document.querySelector(container);
    this.table = this.container.querySelector(".hy-table#main_table")
    this.addBtn = this.container.querySelector(".add-btn")
    this.removeBtn = this.container.querySelector(".remove-btn")
  }

  /*
   * @Overview 데이터 세팅 함수
   * @Parameter 없음
   */
  getMainList(mode,...test) {
    const talert= window.setTimeout(()=> { this.tbList.alert("Loading ...") }, 1000);
    const arr = test;
    const data = new Object();

    for(let i=0; i < arr.length; i++){
      let temp = [arr[i]]
      console.log();
      if(document.getElementById(arr[i]).type == "checkbox"){
          data[temp] = document.getElementById(temp).checked?"Y":"N";
      }else{
          data[temp] = document.getElementById(temp).value

      }
    }
    data.mode = mode
    ajax_json({
      url: this.ajaxUrl,
      data: data,

      success: (data) => {
        if(data.code) {
          this.tbList.setData(data.data);
        }else{
          kuls_alert(data.mesg);
        }
      },
      error: (req, status, err) => {
        kuls_alert(err.message);
      },
      complete: () => {
        window.clearTimeout(talert);
        this.tbList.clearAlert();
      },
    });

    return true;
  }

  /*
   * @Overview 테이블 행 추가 함수
   * @Parameter 없음
   * @function 기본키, _STATUS_:I 값을 넣은 행 추가
   */
  addRow() {
    const today = new Date();
    const date = today.getFullYear() + '-'
    + ( today.getMonth()+1<10 ? '0' + (today.getMonth()+1) : today.getMonth()+1 ) + "-"
    + ( today.getDate()<10 ? '0' + today.getDate() : today.getDate() );

    const time = ( today.getHours()<10 ? '0' + today.getHours() : today.getHours() ) + ":" 
    + ( today.getMinutes()<10 ? '0' + today.getMinutes() : today.getMinutes() )

    this.tbList.addRow({ _STATUS_: "I", DEF_DT: date, DEF_TM: time });
  }

  /*
   * @Overview 테이블 행 삭제 함수
   * @Parameter 없음
   * @function 선택된 모든 행 STATUS D
   */
  removeRow() {
    const selectedRows = this.tbList.getRows().filter(row=>{
      return row.getData().check ==="Y"
    });

    if(selectedRows.length > 0 ){

        // 선택된 각 행 삭제
        selectedRows.forEach((row) => {
          // STAUS D로 바꾸기
          row.getData()._STATUS_ = row.getData()._STATUS_=="I"?null:"D";
    
          const rowElement = row.getElement();
          rowElement.classList.add("remove-row");
    
        });
    }else{
      kuls_alert("삭제할 행을 선택해주세요.")
    }
  }

  /*
   * @Overview 테이블 행 선택 함수
   * @Parameter 없음
   * @function 선택된 모든 행 색 변경
   */
  rowClick(e, tgt) {
    if (tgt.isSelected()) {
      tgt.deselect();
      this.clearRemove(tgt);
    } else {
      tgt.select();
    }
  }

  /*
   * @Overview 삭제 취소 함수
   * @Parameter 삭제 행
   * @function  클릭시 삭제 취소 & STATUS를 공란으로 변경
   */
  clearRemove(tgt){
    if(tgt._row.data._STATUS_ == "D"){
      tgt._row.data._STATUS_ = "";
      tgt._row.getElement().classList.remove("remove-row")
    }
  }

  /*
   * @Overview cell 클릭 함수
   * @Parameter 클릭한 cell
   * @Function 클릭한 cell의 filed 값에 따라 토글 상태 변경 또는 팝업
   */
  cellClick(e, tgt) {
    switch (tgt.getField()) {
      case "WO_NO":
        popOrder({
          WO_NO : "WO_NO",
          WO_SEQ : "WO_SEQ",
          DEF_OP_CD: "OP_CD",
          DEF_FACLT_CD: "FACLT_CD",
          ITEM_CD : "ITEM_CD",
          ITEM_NM: "ITEM_NM",
        },tgt.getRow())
      break;
      case "check":
        tgt.setValue(tgt.getValue() == "Y" ? "" : "Y");
        this.clearRemove(tgt.getRow())
      break;
      case "ACT_EMP_NO":
        popWorker({
          ACT_EMP_NO: 'EMP_NO',
          ACT_EMP_NM: 'EMP_NM'
        }, tgt.getRow())
        break;
    }
  }

  /*
   * @Overview  셀 수정 이벤트
   * @Parameter 없음
   */
  cellEdited(cell) {
    cell.getData()._STATUS_ = cell.getData()._STATUS_ || "U";
  }

  /*
   * @Overview 추가, 수정 및 삭제 데이터 저장
   * @Parameter 없음
   * @Function _STATUS_ : U, I, D Row 인 것 php 처리.
   */
    putData() {
      console.log("hi")
    // let _this = this;

    // 저장 시 상태 변화 없는 row 요청 X
    if(this.tbList.getData().filter(row=> row._STATUS_).length == 0){
      this.getMainList('getDefectList', 'date_st', 'date_ed', 'FACLT_CD');
      return false;
    }


    const blankObj = [];
    const reqData = [];

    this.tbList.getRows().forEach(row => {

      if(row.getData()['_STATUS_']){
        if(Object.keys(row._row.data).filter(key => key !== '_STATUS_').every(key => {

          const value = row._row.data[key];
          return (value === undefined || value === '');
        })){
          blankObj.push(row);
        }else{
          reqData.push(row.getData());
        }
      }
    })

    const postdata = reqData.length == 0 ? false : {
      'mode': 'putDefect',
      'reqdata': JSON.stringify(reqData),
    };

    if(!postdata){
      this.getMainList('getDefectList', 'date_st', 'date_ed', 'FACLT_CD');
      return false;
    };
    if(blankObj.length !== 0){
      
      kuls_confirm("비어있는 행을 무시하고 진행하시겠습니까?","",()=>{
        ajax_json({
          url: this.ajaxUrl,
          data: postdata,
          success: (data)=>{
            if (data.code) {
              kuls_success("저장되었습니다.");
              this.getMainList('getDefectList', 'date_st', 'date_ed', 'FACLT_CD');
            }else{
              kuls_alert(data.mesg);
            }
          },
          error: function (request, status, error) {
            kuls_alert(error.message);
          },
          complete: function () {
          }
        });

      },()=>{
        blankObj.forEach(row=>{
          row.getElement().classList.add("blank-row")
        })
      })
    }else{
      ajax_json({
        url: this.ajaxUrl,
        data: postdata,
        success: (data)=>{
          if (data.code) {
            kuls_success("저장되었습니다.");
            this.getMainList('getDefectList', 'date_st', 'date_ed', 'FACLT_CD');
          }else{
            kuls_alert(data.mesg);
          }
        },
        error: function (request, status, error) {
          kuls_alert(error.message);
        },
        complete: function () {
        }
      });

    
    }

  }

  /*
   * @Overview 최초 실행 함수
   * @Parameter 없음
   */
  init() {
    const fields = [
      { field:"check",   title: "삭제", width: 50, headerSort: false,
        formatter: tb_common_funtions.formatterCheckboxIcon,
        formatterParams: { checkval: "Y" },
      },
      { field: "DEF_NO",       title: "No",      width: 50, formatter: "rownum", },
      { field: "DEF_DT",       title: "작업일",   width: 100, editor:"date",
        formatter:"datetime",
        formatterParams:{
          inputFormat:"yyyy-MM-dd",
          outputFormat:"yyyy.MM.dd",

        },
        cssClass: "editable-cell"
      },
      { field: "DEF_TM",       title: "발생시간", width: 70,
        editor: tb_custom_editor.time,
        cssClass: "editable-cell"
      },
      { field: "WO_NO",        title: "생산오더", width: 70, cssClass: "editable-cell" },  //팝업 수정
      { field: "WO_SEQ",       title: "일련번호", visible: false },  //팝업 수정
      { field: "DEF_OP_CD",    title: "공정",     width: 40 },  //팝업 수정
      { field: "DEF_FACLT_CD", title: "설비",     width: 40 },
      { field: "ITEM_CD",      title: "품목",     width: 70, }, 
      { field: "ITEM_NM",      title: "품명",     minWidth: 300, width:"15%", hozAlign:"left" },
      { field: "DEF_CD",       title: "불량코드", width: 80, cssClass: "user-list editable-cell",
        editor: "list", 
        editorParams:{ values : varsDEF_CD }, 
        formatter: tb_common_funtions.formatterSelect, 
        formatterParams:{ values : varsDEF_CD }, 
      }, //불량원인 코드 설정하기
      { field: "DEF_QTY",      title: "불량<br>수량", width: 40, editor: "input", hozAlign:"right", cssClass: "editable-cell" },
      { field: "DEF_CAUSE",    title: "불량원인", width: 70, editor:"input", hozAlign:"left"},
      { field: "DEF_ACTION",   title: "불량조치내역", width:"15%", editor:"input", hozAlign:"left"},
      { field: "ACT_EMP_NO",   title: "조치자", width: 70, editor:"input"},
      { field: "ACT_DT",       title: "조치일시", width: 70, editor:"date",
        formatter:"datetime",
        formatterParams:{
          inputFormat:"yyyy-MM-dd",
          outputFormat:"yyyy.MM.dd",
        },
      },

      { field: "DEF_PRICE",    title: "불량금액", width: 70, formatter:"money", formatterParams:{ decimal:".",precision:0 }, hozAlign:"right"}, //공정단가(기준정보) x 불량수량 -> 공정단가는 어디에?? 기준정보는 왜 괄호를 쳐놓으신 걸깝?

    ];

    // field 공통 요소
    const commonFieldData = {
      headerSort: true,
      vertAlign: "middle",
      hozAlign: "center",
      resizable: "header", //Resize 는 헤더에서만 가능
      headerHozAlign: "center", //헤더 정렬
      headerSortTristate: true, //데이터 정렬 => 정/역/초기화
    };

    /*
     * @Overview tabulator 객체 생성
     * @Parameter 생성 위치(html class값)
     */
    this.tbList = new Tabulator(this.table, {
      layout: "fitColumns",
      height: "100%",
      data: [], //기본 데이터
      columns: fields, //컬럼 설정
      columnDefaults: commonFieldData,
      // headerSortElement: "<i class='bi'></i>", //정렬 아이콘
      rowFormatter:function(row){
        if(row.getData().USE_FLG != "Y"){
          row.getElement().classList.add('text-secondary');
        }
      },
      headerSortElement: "<i class='bi'></i>", //정렬 아이콘
      validationMode: "highlight"
    });

    /*
     * @Overview 테이블 만들어지면 데이터 불러오기
     * @Parameter 없음
     */
    this.tbList.on("tableBuilt", () => {
      this.getMainList && this.getMainList('getDefectList', 'date_st', 'date_ed', 'FACLT_CD');
    });

    /*
     * @Overview 유효성 검사메세지 띄우기
     * @Parameter cell, 입력값, validators
     */
    this.tbList.on("validationFailed", (cell, value, validators)=>{
      cell.setValue("");
      let errMsg = ""
      switch(validators[0].type){
        case "alphanumeric":
          errMsg = " 필드는 한글과 특수문자를 입력할 수 없습니다.";
          break;
        case "numeric":
          errMsg = " 필드는 숫자만 입력할 수 있습니다.";
          break;
        default:
          errMsg = " 필드는 "+ validators[0].parameters;
          break;
          
      };
      
      kuls_warning(cell.getColumn().getDefinition().title + errMsg );
    });

    /*
     * @Overview cell 클릭시 체크 또는 팝업
     * @Parameter 이벤트, 셀
     */
    this.tbList.on("cellClick", (e, tgt) => {
      this.cellClick && this.cellClick(e, tgt);
    });
    
    /*
     * @Overview cell 수정 함수
     * @Parameter cell
     * @Function status u로 바꿀것
     */
    this.tbList.on("cellEdited", (cell) => {
      this.cellEdited && this.cellEdited(cell);
    });

    // 추가
    ["click", "keypress"].forEach((evt) => {
      this.addBtn.addEventListener(evt, () => {
        this.addRow && this.addRow();
      });
    });
    // 삭제
    ["click", "keypress"].forEach((evt) => {
      this.removeBtn.addEventListener(evt, () => {
        // 삭제 함수
        this.removeRow && this.removeRow();
      });
    });
    // 엑셀
    ["click", "keypress"].forEach((evt) => {
      const excelBtn = document.querySelector("#excel_data");
      excelBtn.addEventListener(evt, () => {
        tb_common_funtions.tabu2xls_px(this.tbList, "불량실적내역", "불량실적내역")
      });
    });
    // 조회
    ["click", "keypress"].forEach((evt) => {
      const filterBtn = document.querySelector(".filter-btn");
      filterBtn.addEventListener(evt, () => {
        // setFilter 또는 setData
        this.getMainList && this.getMainList('getDefectList', 'date_st', 'date_ed', 'FACLT_CD');
      });
    });
    // 저장
    ["click", "keypress"].forEach((evt) => {
      const putBtn = document.querySelector(".put-btn");
      putBtn.addEventListener(evt, () => {
        this.putData && this.putData();
      });
    });
  }
}

const Tb_defect = new Tb_defect_class("#main_container");
Tb_defect.init();